/***********************************************************************
 *
 * dldump.c -- This file contains debugging code to dump the contents
 *             of a doubly-linked list.
 *
 ***********************************************************************/

#include <stdio.h>
#include "dlpriv.h"

#ifdef __STDC__
void dll_dump(DL_LIST plist,void (*key_dump)(void*,void*,void*),void *info)
#else
void dll_dump(plist,key_dump,info)
DL_LIST	plist;
void	(*key_dump)();
void	*info;
#endif
{
	LIST	*list;
	NODE	*this;

	if (plist == NULL)
	{
		printf("ERROR:  Trying to dump null list\n");
		return;
	}

	list = (LIST*) plist;
	printf("List handle located at %x\n",(int) list);
	printf("last = %x\n",(int) list->last);
	printf("current = %x\n",(int) list->current);
	printf("data = %x\n", (int) list->data);
	printf("nextOk = %d\n", list->nextOk);
	printf("size = %d\n", list->size);
	printf("changed = %d\n", list->changed);
	printf("-----------\n");
	if (list->last != NULL)
	{
		this = list->last->next;
		do
		{
			printf("Node at %x:\n",(int) this);
			printf("  next = %x\n",(int) this->next);
			printf("  prev = %x\n",(int) this->prev);
			if (key_dump != NULL)
			{
				key_dump(this->key,this->data,info);
			}
			printf("\n");
			this = this->next;
		} while (this != list->last->next);
	}
	return;
}

/************* End of file ************/

